



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>net 中web.config单一解决方法 （其他配置引入方式）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">net 中web.config单一解决方法 （其他配置引入方式）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 00:26:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>近期一个项目需要写许多的配置项，发现在单个web.config里面写的话会很乱也难于查找</p>
<p>所以搜了一下解决了，记录下来</p>
<p>一、 &nbsp; webconfig提供了引入其他config的方式</p>
<p>&lt;connectionStrings configSource="Configs\database.config" /&gt;</p>
<p>这个是连接字符串的配置你可以在database。config里面写很多链接字符串以备自己调用</p>
<p>database。config里面的内容如下：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;connectionStrings&gt;<br />
  &lt;add name="SDbContext" connectionString="Server=.;Initial Catalog=Self;User ID=sa;Password=password" providerName="System.Data.SqlClient" /&gt;

&lt;/connectionStrings&gt;</pre>
</div>
<p>&lt;appSettings configSource="Configs\system.config" /&gt;</p>
<p>这个是键值对的方式存放代码如下：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;appSettings&gt;<br />
  &lt;!-- ================== 1：开发系统相关配置 ================== --&gt;<br />
  &lt;!-- 登陆提供者模式：Session、Cookie--&gt;<br />
  &lt;add key="LoginProvider" value="Cookie" /&gt;<br />
  &lt;!-- 启用系统日志--&gt;<br />
  &lt;add key="IsLog" value="true" /&gt;<br />
  &lt;!-- 数据库超时间--&gt;<br />
  &lt;add key="CommandTimeout" value="180" /&gt;<br />
  &lt;!--启用IP过滤 --&gt;<br />
  &lt;add key="IsIPFilter" value="false" /&gt;<br />
  &lt;!-- ================== 2：系统软件参数配置 ================== --&gt;<br />
  &lt;!-- 联系我们 --&gt;<br />
  &lt;add key="Contact" value="TE Software(Mobility)" /&gt;<br />
  &lt;!-- 软件名称 --&gt;<br />
  &lt;add key="SoftName" value="Sub Self" /&gt;<br />
  &lt;!-- 软件版本 --&gt;<br />
  &lt;add key="Version" value="1.0" /&gt;

  &lt;!-- 设置就应用路径 --&gt;<br />
  &lt;add key="AppName" value="" /&gt;

  &lt;!-- 设置就应用路径 --&gt;<br />
  &lt;add key="SqlGetBomList" value="" /&gt;<br />
&lt;/appSettings&gt;</pre>
</div>
<p>以上两个是不需要特殊的配置的，放到configuration里面&nbsp;configSections的下面这样就可以</p>
<p>二、下面介绍自定义配置节</p>
<div>
<pre class="prettyprint linenums">&lt;configSections&gt;

   &lt;section name="users" type="System.Configuration.NameValueSectionHandler"/&gt;

 &lt;/configSections&gt;<br />
 &lt;users  configSource="users.config"&gt;&lt;/users&gt;</pre>
</div>
<p>注意configsections里面的一条，是声明这是以什么组织方式</p>
<p>users.config 里面的内容如下：</p>
<div>
<pre class="prettyprint linenums">&lt;users&gt;<br />
  &lt;add key="beijing" value="123"&gt;&lt;/add&gt;<br />
  &lt;add key="tianjin" value="123"&gt;&lt;/add&gt;<br />
&lt;/users&gt;</pre>
</div>
<p>获取配置的方式：</p>
<div>
<pre class="prettyprint linenums">NameValueCollection users = System.Configuration.ConfigurationManager.GetSection("users") as NameValueCollection;<br />
         //   Response.Write(users.Keys[0]+"&lt;/br&gt;"+users.Keys[1]);<br />
users.Get("beijing");</pre>
</div>
<p>　　三、复杂类型：</p>
<p>复杂类型的声明就不同了</p>
<div>
<pre class="prettyprint linenums">&lt;configSections&gt;

&lt;section name="roles" type="EBuy.Chapter3.NTier.WebUI.RolesConfig, EBuy.Chapter3.NTier.WebUI"/&gt;

&lt;/configSections&gt;<br />
&lt;roles configSource="roles.config"&gt;<br />
  &lt;/roles&gt;</pre>
</div>
<p>内容如下</p>
<div>
<pre class="prettyprint linenums">&lt;roles&gt;<br />
  &lt;add username="beijing" password="123"&gt;&lt;/add&gt;<br />
  &lt;add username="tianjin" password="123"&gt;&lt;/add&gt;<br />
&lt;/roles&gt;</pre>
</div>
<p>获取方式：</p>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Web;<br />
namespace EBuy.Chapter3.NTier.WebUI<br />
{<br />
    public class RolesConfig : System.Configuration.IConfigurationSectionHandler<br />
    {<br />
        public object Create(object parent, object configContext, System.Xml.XmlNode section)<br />
        {<br />
            return section;<br />
        }<br />
    }<br />
}<br />
　　

XmlNode roles= System.Configuration.ConfigurationManager.GetSection("roles") as XmlNode;<br />
           Response.Write(roles.ChildNodes [].Attributes["username"].InnerText);</pre>
</div>
<p>还可以配置为实体</p>
<div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Web;<br />
namespace EBuy.Chapter3.NTier.WebUI<br />
{<br />
    public class RolesConfig : System.Configuration.IConfigurationSectionHandler<br />
    {<br />
        public object Create(object parent, object configContext, System.Xml.XmlNode section)<br />
        {<br />
            var list=new List&lt;Role&gt;();<br />
            for(int i=0;i&lt;section.ChildNodes.Count;i++)<br />
            {<br />
                list.Add(new Role (){<br />
                    Username =section.ChildNodes[i].Attributes["username"].InnerText ,<br />
                    Password =section.ChildNodes[i].Attributes["password"].InnerText });<br />
            }<br />
            return list;<br />
        }<br />
    }<br />
    public class Role<br />
    {<br />
        public string Username { get; set; }<br />
        public string Password{get;set;}<br />
    }<br />
}<br />
　　

var roles = System.Configuration.ConfigurationManager.GetSection("roles") as List&lt;EBuy.Chapter3.NTier.WebUI.Role &gt;;<br />
          Response.Write(roles.First ().Username);
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxyne9y.html">js动态加载css和js</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e4yvm9.html">ie8 jquery parents&lpar;&rpar; 获取多个的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93pprz8.html">&lbrack;DOM Event Learning&rsqb; Section 3 jQuery事件处理基础 on&lpar;&rpar;&comma; off&lpar;&rpar;和one&lpar;&rpar;方法使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ky7739.html">groovy&ndash;运算符重载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydy222q.html">C&bsol;C&plus;&plus;拾遗------C&num;程序员重温C&bsol;C&plus;&plus;之要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wkgywq.html">a标签至于flash之上的时候，IE浏览器无法点击连接的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0e6xq.html">SQL数据缓存依赖 &lbrack;SqlServer &vert; Cache &vert; SqlCacheDependency &rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qder1yz9.html">C&plus;&plus;空类以及没有成员变量的类的大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vgxwj8.html">&period;&sol;configure 时候报错c&plus;&plus; 编译器不能执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1vnkyq.html">30分钟快速掌握AngularJs</a>
		</li>
						<li><a href="https://www.batexi.com/a/950wg4z8.html">CentOS&lowbar;5&period;6下使用cmake编译MySQL&lowbar;5&period;5&period;11</a>
		</li>
						<li><a href="https://www.batexi.com/a/8merj10q.html">关闭 Activity 关闭方式 finish&lpar;&rpar;&comma; exit&lpar;&rpar;&comma; killProcess&lpar;&rpar;&comma; restartPackage&lpar;&rpar;&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkzx5v8.html">Linux系列教程（十五）&mdash;&mdash;Linux用户和用户组管理之用户管理命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj72wz8.html">openwrt路由器进入安全模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwe04z9.html">DAY6：文件读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydejmq.html">MyBatis学习总结-MyBatis快速入门的系列教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll0zzxq.html">np&period;percentile&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o10pklq.html">给PHP开启shmop扩展实现共享内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/96066p49.html">做为一个&period;net码农，打开公司的一个项目，大叔我哭了</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kmp1379.html">如何用Elasticsearch实现类似SQL中的IN查询实例</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2j2y138.html">模板类的约束模板友元函数：template friend functions</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpvrx69.html">前端魔法堂：屏蔽Backspace导致页面回退</a>
			</li>
						<li><a href="https://www.batexi.com/a/950wndv8.html">Linux环境下配置JDK，java环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1r76oq.html">spring-定时器&lpar;1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpv6659.html">php curl&lowbar;setopt的相关设置查询手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojgpmeq.html">&num; Instrument Time Profiler教程之Time Profiler</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge5y0z8.html">TreeSet集合排序方式一：自然排序Comparable</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk5mkd8.html">C&plus;&plus;抽象编程&amp;&num;183&semi;运算符重载与友元函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpzyy0q.html">iOS  enum C方法  DEBUG&comma; RELEASE的隐藏的一个坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg1xnd8.html">请教 C&num; 异步  async await 问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
